main()
{
	ambientPlay("ambient_eerie");

	thread death_check();
	thread objective();
	thread platforms();
	thread spike1();
	thread spike2();
}

objective()
{
trig_obj = getent("trig_obj","targetname");
trig_loc = getent("trig_location","targetname");
obj = getent("objective","targetname");

while(1)
{
trig_obj waittill ("trigger",user);
user.holdobj = 1;
user thread watchobj();
obj hide();
trig_obj thread maps\mp\_utility::triggerOff();

user iprintln("You have stolen the objective!");
while(user.holdobj == 1)
{
	if(user isTouching(trig_loc))
	{
		user iprintln("You have retrieved the objective!");
		user iprintln("Well done!");
		wait 2;
		if(user.health > 1)
			user suicide();
		
		user.holdobj = 0;
		obj show();
		trig_obj thread maps\mp\_utility::triggerOn();
		user notify("objective_dropped");
	}
	wait 0.5;
}
wait 0.05;
}
}

watchobj()
{
	self endon("objective_dropped");
	obj = getent("objective","targetname");
	trig_obj = getent("trig_obj","targetname");
	
for(;;)
	{
	
	if(self.health < 1)
		{
		self.holdobj = 0;
		obj show();
		trig_obj thread maps\mp\_utility::triggerOn();
		self iprintln("You have dropped the objective!");
		break;
		}
		wait 1;
	}
}

platforms()
{
	platform = getentarray("platform","targetname");
	for(i=0;i<platform.size;i++)
	platform[i] thread platform_move();
}

platform_move()
{	
	while(1)
	{
	self moveY (88, (randomfloat(.5) + 1));
	self waittill ("movedone");
	self moveY (-88, (randomfloat(.5) + 1));
	self waittill ("movedone");
	}
}

spike1()
{
spike1 = getent("spike1","targetname");
trig = getent("spike1trig","targetname");
killzone = getent("killzone1","targetname");

while(1)
{
trig waittill ("trigger",user);
wait 0.7;
user playSound("spike");
spike1 moveZ(66,0.1);
wait 0.1;
if (user isTouching(killzone) || user isTouching(spike1))
	{
	user suicide();
	}

wait 1;
	
spike1 moveZ(-66,0.1);
wait 1;
}
}

spike2()
{
spike2 = getent("spike2","targetname");
trig = getent("spike2trig","targetname");
killzone = getent("killzone2","targetname");

while(1)
{
trig waittill ("trigger",user);
wait 0.7;
user playSound("spike");
spike2 moveZ(66,0.1);
wait 0.1;
if (user isTouching(killzone) || user isTouching(spike2))
	{
	user suicide();
	}
	
wait 1;
	
spike2 moveZ(-66,0.1);
wait 1;
}
}

death_check()
{
trigger = getent("start","targetname");

trigger waittill ("trigger",user);
for(;;)
	{
	if(user.health < 1)
		{
		user playLocalSound("laugh");
		wait 5;
		}
	wait 0.1;
	}
}